# -*- coding: utf-8 -*-

"""
Module with some tools to manipulate lithologies.
"""
from __future__ import absolute_import

from builtins import object
import os

from PyQt5.QtWidgets import QComboBox, QSizePolicy
from PyQt5.QtGui import QPixmap, QIcon
from PyQt5.QtCore import QSize

from qgis.gui import QgsMapToolEmitPoint

class CtrlCraftLithologyUpdateMapTool(QgsMapToolEmitPoint):

    def __init__(self, lithology):
        QgsMapToolEmitPoint.__init__(self, lithology.master.canvas)
        self.lithology = lithology

    def canvasReleaseEvent(self, event):
        pt = event.mapPoint()
        name = self.lithology.name

        if self.lithology.master.data.is_valid():
            self.lithology.master.data.lithology_update(name, pt)
            self.lithology.master.refresh()


class CtrlCraftLithology(object):

    def __init__(self, master, name):
        self.master = master
        self.mapTool = None
        self.name = name

    def activateMapTool(self):
        self.mapTool = CtrlCraftLithologyUpdateMapTool(self)
        self.mapTool.setAction(self.action)
        self.master.canvas.setMapTool(self.mapTool)
